(function($) {
	var settings = {
		navi: 'ul.h-navigator',
		sub: 'ul.sub-navigator'
	};

	var subs;

	$.fn.floatNavigator = function(options) {
		subs = $(settings.sub);

		$(this.selector + ' li').mouseover(function() {
			var $this = $(this);
			var activeSubNavigator = subs.eq($this.index());

			$this.siblings().removeClass('active');
			if (activeSubNavigator.children().size() == 0) {
				subs.css('display', 'none');
				return $this;
			}
			$this.addClass('active');

			activeSubNavigator.css('display', 'block')
				.siblings(settings.sub).css('display', 'none');

			var parentWidth = $(settings.navi).width();

			var targetWidth = $this.outerWidth(true);
			var targetInnerWidth = $this.innerWidth();
			var targetOffset = $this.position().left;

			var activeWidth = activeSubNavigator.outerWidth();
			var activeInnerWidth = activeSubNavigator.innerWidth();

			if (activeWidth / 2 < targetOffset + targetWidth / 2) {
				var offset = targetOffset + (targetWidth - targetInnerWidth);
				offset -= (activeWidth - targetInnerWidth) / 2;
				var overflow = (activeWidth + offset) - parentWidth;
				if (overflow > 0)
					offset -= overflow;
				activeSubNavigator.css('left', offset);
			}

			return $this;
		});
	};

	$(document).ready(function() {
		$(settings.navi).floatNavigator();
		$("ul.h-navigator li.active").mouseover();
	});
})(jQuery);
