/*\
|*| Script creates tabbed announce block + announce block selector
|*|
|*| Depencies: jquery, jquery.tools
\*/
(function($){
	Slideshow = function(args) {
		if (args) {
			this.container = args.container;
			this.item = args.item;
			this.items = args.container + ' > ' + args.item;
			this.interval = args.interval;
			this.controls = args.controls;
			this.next = args.next;
			this.prev = args.prev;
			this.play = args.play;
			this.stop = args.stop;
	
			this.toggle = args.toggle || this.controls + ' > .toggle';					
			this.current = args.current || this.controls + ' .current';
			this.total = args.total || this.controls + ' .total';
		}
	};
	
	Slideshow.prototype = {
		init: function() {
			$(this.container).tabs(this.items, {
				tabs: this.item,
				effect: 'fade',
				interval: 5000,
				fadeOutSpeed: 'slow',
				rotate: 'true'
			}).slideshow({
				autoplay: 'true',
				next: this.next,
				prev: this.prev
			});
	
			// some bydlocode
			// slideshow is actually self-clicked
			$($(this.container).data('tabs')).bind('onClick', { props: this }, this.refreshIndex);
			$(this.total).text($(this.items).size());
	
			// play/stop
			$(this.toggle).click({ props: this }, this._toggle);
	
			// show/hide controls
			$(this.container)
				.mouseenter({ c: this.controls }, function(e) { $(e.data.c).fadeIn(100); })
				.mouseleave({ c: this.controls }, function(e) { $(e.data.c).fadeOut(100); });
		},
	
		// play/stop
		_toggle: function(e) {
			var sshow = $(e.data.props.container).data('slideshow');
			if ($(this).hasClass('play'))
				sshow.play();
			else if ($(this).hasClass('stop'))
				sshow.stop();
				$(this).toggleClass('play stop');
			},
						
			refreshIndex: function(e, index) {
				$(e.data.props.current).text(index + 1);
			}
	};
})(jQuery);
